
class Constants:

    IG_SIG_KEY = 'e1712d2f592becfdea858c4d0ad4e7c5f230c446094155a1663d612e1290c841'
    IG_CAPABILITIES = '3ToAAA=='    # = base64.b64encode(struct.pack('<i', 15069)).decode('ascii')
    SIG_KEY_VERSION = '4'

    APP_VERSION = '10.9.0'
    ANDROID_VERSION = 18
    ANDROID_RELEASE = '4.3'
    PHONE_MANUFACTURER = 'Xiaomi'
    PHONE_DEVICE = 'HM 1SW'
    PHONE_MODEL = 'armani'
    PHONE_DPI = '320dpi'
    PHONE_RESOLUTION = '720x1280'
    PHONE_CHIPSET = 'qcom'

    USER_AGENT_FORMAT = \
        'Instagram %(app_version)s Android (%(android_version)d/%(android_release)s; ' \
        '%(dpi)s; %(resolution)s; %(brand)s; %(device)s; %(model)s; %(chipset)s; en_US)'

    USER_AGENT_EXPRESSION = \
        r'Instagram\s(?P<app_version>[^\s]+)\sAndroid\s\((?P<android_version>[0-9]+)/(?P<android_release>[0-9\.]+);\s' \
        r'(?P<dpi>\d+dpi);\s(?P<resolution>\d+x\d+);\s(?P<manufacturer>[^;]+);\s(?P<device>[^;]+);\s' \
        r'(?P<model>[^;]+);\s(?P<chipset>[^;]+);'

    USER_AGENT = USER_AGENT_FORMAT % {
        'app_version': APP_VERSION,
        'android_version': ANDROID_VERSION,
        'android_release': ANDROID_RELEASE,
        'brand': PHONE_MANUFACTURER,
        'device': PHONE_DEVICE,
        'model': PHONE_MODEL,
        'dpi': PHONE_DPI,
        'resolution': PHONE_RESOLUTION,
        'chipset': PHONE_CHIPSET}

    LOGIN_EXPERIMENTS = 'ig_android_background_phone_confirmation_v2,ig_android_confirmation_code_registration,ig_android_non_fb_sso,ig_android_sms_consent_in_reg,ig_android_analytics_data_loss,ig_fbns_blocked,ig_android_gmail_oauth_in_reg,ig_android_show_password_in_reg_universe,ig_android_reg_inline_errors,ig_fbns_push,ig_android_gmail_oauth_in_access,ig_android_reg_whiteout_redesign_v2,ig_android_phoneid_sync_interval,ig_android_access_redesign,ig_android_link_to_access_if_email_taken_in_reg'   # noqa

    EXPERIMENTS = 'ig_android_ad_holdout_16m5_universe,ig_creation_growth_holdout,ig_android_business_conversion_social_context,ig_android_shopping,ig_android_ad_always_send_ad_attribution_id_universe,ig_android_direct_links,ig_android_insta_video_abr_resize,ig_android_special_brush,ig_android_stories_private_likes,ig_android_universe_video_production,ig_android_http_stack_experiment_2017,ig_android_enable_main_feed_reel_tray_preloading,ig_android_ad_cta_redesign_universe,ig_fbns_push,ig_android_live_special_codec_size_list,ig_android_direct_send_auto_retry,ig_android_preview_capture,ig_android_stories_book_universe,android_instagram_prefetch_suggestions_universe,ig_android_direct_video_autoplay_scroll,ig_android_offline_location_feed,ig_android_histogram_reporter,ig_android_exoplayer_4142,ig_android_draw_button_new_tool_animation,ig_android_disable_comment,ig_android_offline_likes_v2,ig_android_high_res_upload_2,ig_android_direct_address_links,ig_android_chaining_teaser_animation,ig_android_2fac,ig_android_react_native_lazy_modules_killswitch,ig_android_checkbox_instead_of_button_as_follow_affordance_universe,ig_android_insta_video_audio_encoder,ig_android_grid_video_icon,ig_android_image_disk_cache_max_entry_count,ig_android_mark_reel_seen_on_Swipe_forward,ig_android_disable_chroma_subsampling,ig_android_share_spinner,ig_android_reel_viewer_data_buffer_size,ig_android_video_reuse_surface,ig_android_offline_reel_feed,ig_android_offline_follows,ig_android_instavideo_periodic_notif,ig_android_snippets_haptic_feedback,ig_request_cache_layer,ig_android_promote_loading_screen_image,ig_android_unified_inbox,ig_android_stories_teach_gallery_location,ig_android_top_live_titles_universe,ig_android_insta_video_reconnect_viewers,ig_android_new_block_flow,ig_android_remove_followers_universe,ig_android_direct_link_style,ig_android_boomerang_feed_attribution,ig_android_text_background,ig_fbns_shared,ig_android_react_native_universe,ig_android_live_see_fewer_videos_like_this_universe,ig_android_snippets_profile_nux,ig_android_video_loopcount_int,ig_android_profile_photo_as_media,ig_android_direct_sqlite_universe,ig_android_camera_universe,ig_video_max_duration_qe_preuniverse,ig_android_ad_show_mai_cta_loading_state_universe,ig_android_swipe_navigation_x_angle_universe,ig_android_profile,ig_android_empty_feed_redesign,ig_android_direct_blue_tab,ig_android_video_single_surface,ig_android_enable_share_to_messenger,ig_android_mqtt_skywalker,ig_ranking_following,ig_family_bridges_holdout_universe,ig_android_stories_weblink_creation,ig_android_ad_fix_missing_viewed_time_events_universe,ig_android_insta_video_broadcaster_infra_perf,ig_android_sms_consent_in_edit_profile,ig_android_full_user_detail_endpoint,ig_android_mead,ig_android_profile_share_username,ig_android_asset_button_new_content_animation,ig_android_verified_comments_universe,ig_android_business_conversion_value_prop_v2,ig_android_http_stack_kz_debug,ig_android_sticker_tap_affordance_more_prominent,ig_android_etag_layer,ig_android_su_in_feed_unit_redesign,ig_android_keep_http_cache_on_user_switch,ig_android_retry_story_seen_state,ig_android_live_analytics,ig_android_su_activity_feed,ig_android_offline_commenting,ig_android_immersive_viewer,ig_android_video_keep_screen_on,ig_android_links_receivers,ig_android_family_bridge_discover,ig_android_save_collections,ig_android_gl_drawing_marks_after_undo_backing,ig_android_business_action,ig_save_insights,ig_android_channels_home,ig_android_mark_seen_state_on_viewed_impression,ig_android_non_square_first,ig_android_log_mediacodec_info,ig_android_react_native_universe_kill_switch,ig_android_stories_weblink_consumption,ig_android_insta_video_drawing,ig_android_facebook_twitter_profile_photos,ig_android_view_pager_paging_check_fix,ig_android_should_sample_ppr,ig_android_infinite_scrolling_launch,ig_android_swipeable_filters_blacklist,android_ig_fbns_kill_switch,ig_android_direct_video_autoplay,ig_android_share_to_whatsapp,ig_android_direct_mutually_exclusive_experiment_universe,ig_android_progressive_jpeg,ig_android_redirect_to_low_latency_universe,ig_android_stories_tray_etag_layer,ig_android_swipeablefilters_universe,ig_android_insta_video_sound_always_on,ig_android_share_profile_photo_to_feed_universe,ig_android_capture_slowmo_mode,ig_android_light_status_bar,ig_android_instavideo_remove_nux_comments,ig_android_instavideo_audio_only_mode,ig_fbns_blocked,ig_fbns_preload_default,ig_promotions_unit_in_insights_landing_page,ig_android_post_auto_retry_v7_21,ig_android_direct_typing_indicator,ig_android_direct_phone_number_links,ig_android_network_cancellation,ig_android_anrwatchdog,ig_android_search_client_matching,ig_android_user_detail_endpoint,ig_android_os_version_blocking,ig_android_add_follow_button_to_direct_thread_details,ig_android_sfplt,ig_android_show_sidecar_insights,ig_android_ad_watchbrowse_universe,ig_android_insta_video_consumption_titles,ig_android_family_bridge_bookmarks,ig_android_offline_main_feed,ig_android_fb_topsearch_sgp_fork_request,ig_android_sidecar,ig_android_memory_improve_universe,ig_android_media_favorites,ig_android_live_enhanced_end_screen_universe,ig_android_save_all,ig_android_insta_video_universe,ig_android_promote_from_profile_button,ig_android_stories_device_tilt,ig_android_universe_reel_video_production,ig_android_ontact_invite_universe,ig_android_offline_hashtag_feed,ig_android_disk_cache_has_sanity_check,ig_android_camera_cover_perf_improvement,ig_explore_netego,ig_android_samsung_app_badging,ig_android_disk_usage,ig_android_business_promotion,ig_android_live_save_to_camera_roll,ig_android_comment_tweaks_universe,ig_android_suggest_password_reset_on_oneclick_login,ig_android_disk_cache_match_journal_size_to_cache_max_count,ig_android_react_native_usertag,ig_android_offline_story_stickers,ig_android_feedvideoplayer_consistent_volume,ig_fbns_dump_ids,ig_android_feed_header_profile_ring_universe,ig_android_live_join_comment_ui_change,ig_in_feed_commenting,ig_android_direct_inbox_count,ig_android_rendering_controls,ig_android_live_stop_broadcast_on_404,ig_formats_and_feedbacks_holdout_universe,ig_video_copyright_whitelist,ig_android_insta_video_consumption_infra,ig_android_disable_comment_public_test,ig_android_offline_mode_holdout,ig_android_insta_video_consumption,ig_android_render_iframe_interval,ig_android_cache_layer_timeout,ig_android_pending_request_search_bar,ig_android_ad_rn_preload_universe,ig_android_toplive_verified_badges_universe,ig_android_discover_page_find_people_buttons,ig_android_explore_story_sfslt_universe,ig_android_search,ig_android_boomerang_entry,ig_android_fb_invite_in_followers_list,ig_android_insta_video_titles_universe,ig_android_send_direct_typing_indicator,ig_android_business_conversion_value_prop_navigate,ig_android_live_like_button_position_test,ig_video_use_sve_universe,ig_android_explore_verified_badges_stories_universe,ig_android_live_skin_smooth,ig_android_marauder_update_frequency,ig_android_family_bridge_share,ig_android_exoplayer_holdout,ig_android_offline_reel_profile,ig_android_add_to_last_post,ig_android_offline_freshness_toast_10_8,ig_android_offline_explore_10_8,ig_android_react_native_restart_after_error_universe,ig_android_video_captions_universe,ig_android_last_edits,ig_android_video_download_logging,ig_android_ad_carousel_redesign_universe,ig_android_comment_deep_linking_v1,ig_android_snippets_feed_tooltip,ig_android_async_network_tweak_universe,ig_android_use_software_layer_for_kc_drawing_universe,ig_android_react_native_ota,ig_android_following_follower_social_context'  # noqa
